In order to use paver, the first thing you need to do is install paver using pip or yum. It is an open source python library that works with python 2 and 3, so it is completely usable.

Once you've installed paver, the next step is to modify the parameters within the constants.py file. With this file, you should have all the parameters for the server that you are accessing. The important thing to remember is that with this approach you can only connect to one server at a time. You will need to modify the constants.py and the db_utils.py in order to connect to multiple servers.

The next step is to modify db_utils.py file. For line 35 - 38, you can modify this to whatever database connection library you use. The pyodbc library can maintain connections to SQL Server and Oracle. We use pymssql because it has a lot more targeted functionality for SQL Server. We include a webhooks function so that you can communicate with any webhooks applicable application (Teams, Slack, etc) that allow you to communicate the various steps of the run of the ETL. All of the webhooks references are currently commented out. In terms of SQL execution, one thing to understand is the reference to the variable prefix. Within all of our SQL scripts, we use the string "<prefix>" in our reference to the context. When we execute our function, it replaces the string "<prefix>" with the prefix referenced in the function. An example of a SQL script is provided within the test.sql file. Of note, the test.sql file will not work unless the string is replaced properly, so the SQL scripts are only executable within the context of the paver workflow. In terms of the SQL execution, we collect metrics on what the SQL script affects. Commented out are the sql_cmd_before and sql_cmd_after statements which help us track what tables were changed and by how many rows. We also collect data points using the ARCH.dbo.SUPER_LOG table, which tracks start, stop, and error data points. In terms of database connection libraries, change line 213 to all the errors that are specific to your database connection library. For the db_utils.py file to work properly, make sure you create the log folder wherever you are executing this workflow. This was coded to all be within the same directory. You can modify it to work in other directories as well, but the most important part is the pavement.py file.


The next step is to modify the pavement.py file. In order to have the task show up when you run paver help, you need to ensure that it has the @task decorator. The @needs decorator references functions in the same or other python files. The convention is just a comma separated list of functions that will be run when you call the function. Within this sample pavement.py, the test_out_script function will run the test_statement function referenced in the test.py file. The comment within the function is the description populated when you do paver help. You can add an infinite number of functions within the needs decorator to be executed. We have it broken up into various levels, with functions referencing other functions, and those referencing the specific scripts. 

The test.py file has a sample function and shows how the SQL scripts are specified. You need to use the @task in order to make it reference-able by paver. The run_scripts decorator is how SQL scripts are executed. As long as you have a prefix (in our case it is the context to be changed in the SQL script), and then an infinite list of SQL scripts. You can separate them with commas, and as long as the first parameter is specified to be the prefix, the other parameters will be executed one by one, in the order that they are specified. 

Some quick tips: the @no_help decorator can be used within the pavement file to suppress it showing up in paver help. Also, to the best of our knowledge, the function specified in the @needs section always get executed before anything placed within the function itself, i.e., if you put any code within the test_statement function from test.py, it will run the SQL script before it does anything within the function.